Bug 694724 - [kn_IN] 0CB0 + 200D + 0CCD + 0C95+ 0CBE consonant is wrongly rendering
[kn_IN] 0CB0 + 200D + 0CCD + 0C95+ 0CBE consonant is wrongly rendering
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: lohit-kannada-fonts (Show other bugs)
19
x86_64 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Pravin Satpute
Fedora Extras Quality Assurance
: i18n
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-04-08 02:44 EDT by Shankar Prasad
Modified: 2015-04-21 00:34 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-05-31 06:57:15 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Actual and correct rendering (109.93 KB, image/png)
2011-04-08 02:44 EDT, Shankar Prasad
no flags Details
Using different rendering engines (182.92 KB, image/png)
2011-04-08 02:48 EDT, Shankar Prasad
no flags Details
ZWJ in Windows XP (3.84 KB, image/png)
2011-11-03 03:53 EDT, Aravinda
no flags Details
ZWJ in Win 7 (5.25 KB, image/png)
2011-11-03 03:54 EDT, Aravinda
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
Sourceware 58714 None None None Never

  None (edit)
Description Shankar Prasad 2011-04-08 02:44:18 EDT
Created attachment 490712 [details]
Actual and correct rendering

Description of problem:
ra+ ZWJ+ halanth + consonant + aa (0CB0 + 200D + 0CCD + 0C95+ 0CBE) is wrongly rendering

Version-Release number of selected component (if applicable):
lohit-kannada-fonts-2.4.5-4.fc14.noarch

How reproducible:
Every time

Steps to Reproduce:
1.Open any text editor (say gedit)
2.Input following raw code key sequence:
0CB0 + 200D + 0CCD + 0C95+0CBE
3.Look at the resulting glyph

Actual results:
Shown in the attachment

Expected results:
Shown in the attachment

Additional info:
This was tested with following rendering engines:
libicu-4.4.1-6.fc14.x86_64
qt-4.7.1-17.fc14.x86_64
pango-1.28.1-5.fc14.x86_64
Comment 1 Shankar Prasad 2011-04-08 02:48:27 EDT
Created attachment 490713 [details]
Using different rendering engines
Comment 2 Aravinda 2011-11-02 16:10:05 EDT
Hi Pravin,

Got some more clue but still confused about ZWJ and ZWNJ issue.

Kedage font has no issues when tested with ICU rendering engine(XeLaTeX and LibreOffice). 

Steps:
1. Copy ರ‍್ಯಾಂಕ್ to OpenOffice/LibreOffice
2. Select text and change font to Kedage and check.
3. Select text and change font to Lohit Kannada and check.

Examined Kedage fonts and Lohit Kannada fonts to see the difference between two fonts about ZWJ implementation. Kedage font didn't have glyph for ZWJ(empty glyph). 

So for testing I cleared the ZWJ glyph(Right click and clear) and then generated the font with different name. Now Lohit Kannada also works fine with ICU rendering engine.

But all Kannada fonts fail to render properly in Pango and QT. (As of now works in ICU)
Haven't tested in Harfbuzz because of some Harfbuzz compilation issue in my machine.

Please suggest how we can proceed to fix this issue. 

-- 
Regards 
Aravinda | ಅರವಿಂದ
http://aravindavk.in
Comment 3 Pravin Satpute 2011-11-03 01:01:38 EDT
Kedage fails in harfbuzz-ng as well 
Problem in pango and qt as well. Removing character is not correct solution.

any idea about windows, is it work there?
Comment 4 Aravinda 2011-11-03 01:22:59 EDT
(In reply to comment #3)
> Kedage fails in harfbuzz-ng as well 
> Problem in pango and qt as well. Removing character is not correct solution.
> 
> any idea about windows, is it work there?

@Pravin, I didn't mentioned the solution, I removed the glyph only to confirm the behaviour of ICU and I was curious about how Kedage font is rendering. 

Awaiting pointers to fix this issue. 

Right now, don't have the windows machine, will get the screen shot and upload.
Comment 5 Aravinda 2011-11-03 03:53:46 EDT
Created attachment 531502 [details]
ZWJ in Windows XP
Comment 6 Aravinda 2011-11-03 03:54:17 EDT
Created attachment 531503 [details]
ZWJ in Win 7
Comment 7 Aravinda 2011-11-03 03:54:35 EDT
In Windows before PR37(http://unicode.org/review/pr-37.pdf) announced they adopted ZWNJ to render these cases. Fixed this issue in Windows 7.
So tested both cases in Windows. Enclosed the screenshots from Win XP and Win7.
Comment 8 Pravin Satpute 2011-11-03 05:35:23 EDT
Me too tested in Windows vista, but lohit and default windows font does not give correct behaviour. 

Since it is working in "Windows 7" i am sure we need fix from rendering engine side.

kindly report bug @ http://bugs.icu-project.org/trac/newticket , might be you know already regarding harfbuzz-ng project. Its still under development i will add this test case into it.
Comment 9 Omshivaprakash 2011-11-05 13:43:45 EDT
My investigation on this issue using Tunga on LibreOffice

1. Typing the following key sequence using kn-itrans renders ರ‌್ಯಾಂಕ್  just fine.


Key sequence - ra + zwj (shift + space) + .h (for halant) + yaaMk
Comment 10 Fedora Update System 2012-03-01 06:02:57 EST
lohit-oriya-fonts-2.5.1-1.fc17,lohit-kannada-fonts-2.5.1-1.fc17,lohit-punjabi-fonts-2.5.1-1.fc17,lohit-telugu-fonts-2.5.1-1.fc17,lohit-malayalam-fonts-2.5.1-1.fc17,lohit-gujarati-fonts-2.5.1-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/lohit-oriya-fonts-2.5.1-1.fc17,lohit-kannada-fonts-2.5.1-1.fc17,lohit-punjabi-fonts-2.5.1-1.fc17,lohit-telugu-fonts-2.5.1-1.fc17,lohit-malayalam-fonts-2.5.1-1.fc17,lohit-gujarati-fonts-2.5.1-1.fc17
Comment 11 Fedora Update System 2012-03-01 06:06:42 EST
lohit-gujarati-fonts-2.5.1-1.fc16,lohit-malayalam-fonts-2.5.1-1.fc16,lohit-telugu-fonts-2.5.1-1.fc16,lohit-punjabi-fonts-2.5.1-1.fc16,lohit-kannada-fonts-2.5.1-1.fc16,lohit-oriya-fonts-2.5.1-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/lohit-gujarati-fonts-2.5.1-1.fc16,lohit-malayalam-fonts-2.5.1-1.fc16,lohit-telugu-fonts-2.5.1-1.fc16,lohit-punjabi-fonts-2.5.1-1.fc16,lohit-kannada-fonts-2.5.1-1.fc16,lohit-oriya-fonts-2.5.1-1.fc16
Comment 12 Fedora Update System 2012-03-01 19:59:24 EST
Package lohit-oriya-fonts-2.5.1-1.fc17, lohit-kannada-fonts-2.5.1-1.fc17, lohit-punjabi-fonts-2.5.1-1.fc17, lohit-telugu-fonts-2.5.1-1.fc17, lohit-malayalam-fonts-2.5.1-1.fc17, lohit-gujarati-fonts-2.5.1-1.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing lohit-oriya-fonts-2.5.1-1.fc17 lohit-kannada-fonts-2.5.1-1.fc17 lohit-punjabi-fonts-2.5.1-1.fc17 lohit-telugu-fonts-2.5.1-1.fc17 lohit-malayalam-fonts-2.5.1-1.fc17 lohit-gujarati-fonts-2.5.1-1.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-2820/lohit-oriya-fonts-2.5.1-1.fc17,lohit-kannada-fonts-2.5.1-1.fc17,lohit-punjabi-fonts-2.5.1-1.fc17,lohit-telugu-fonts-2.5.1-1.fc17,lohit-malayalam-fonts-2.5.1-1.fc17,lohit-gujarati-fonts-2.5.1-1.fc17
then log in and leave karma (feedback).
Comment 13 Pravin Satpute 2012-03-02 01:15:15 EST
I have not fixed this bug yet. This is look like from rendering engine side.
Comment 14 Fedora Update System 2012-03-06 14:37:02 EST
Package lohit-gujarati-fonts-2.5.1-1.fc16, lohit-malayalam-fonts-2.5.1-1.fc16, lohit-telugu-fonts-2.5.1-1.fc16, lohit-punjabi-fonts-2.5.1-1.fc16, lohit-kannada-fonts-2.5.1-1.fc16, lohit-oriya-fonts-2.5.1-1.fc16:
* should fix your issue,
* was pushed to the Fedora 16 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing lohit-gujarati-fonts-2.5.1-1.fc16 lohit-malayalam-fonts-2.5.1-1.fc16 lohit-telugu-fonts-2.5.1-1.fc16 lohit-punjabi-fonts-2.5.1-1.fc16 lohit-kannada-fonts-2.5.1-1.fc16 lohit-oriya-fonts-2.5.1-1.fc16'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-3083/lohit-gujarati-fonts-2.5.1-1.fc16,lohit-malayalam-fonts-2.5.1-1.fc16,lohit-telugu-fonts-2.5.1-1.fc16,lohit-punjabi-fonts-2.5.1-1.fc16,lohit-kannada-fonts-2.5.1-1.fc16,lohit-oriya-fonts-2.5.1-1.fc16
then log in and leave karma (feedback).
Comment 15 Pravin Satpute 2012-12-24 07:01:49 EST
I did some more analysis on this.

1. This combination works proper on Windows with Tunga fonts. 
2. Lohit Kannada fails with Windows8, so i think we need fix in Lohit Kannada.

But same time Tunga font fails with Harfbuzz as well, so we need to wait for Harfbuzz to fix this. Once that done we can add some specific rules in Lohit to handle this sequence.

Unicode has entry for this behaviour:- Unicode Chapter 9-> Kannada -> Consonant Clusters Involving RA provides more information on same.
Comment 16 Aravinda 2012-12-24 10:02:11 EST
I fixed this issue in Gubbi font. Works fine with Harfbuzz. 
https://github.com/downloads/aravindavk/Gubbi/Gubbi-1.3.zip
Comment 17 Pravin Satpute 2012-12-26 02:18:53 EST
Aravinda. That's nice.

As per Unicode this combination only allowed for Ra, you have added all consonants for this one. Do you have any other reference or uses for this?
Comment 18 Aravinda 2013-01-04 04:35:30 EST
Pravin, You are right. We need that rule only for Ra. I will modify the rule accordingly. 

I didn't find any reference to change this, I used hb-shape to see the reordering so that I will understand which rule is failing or which rule is required.
Comment 19 Pravin Satpute 2013-01-04 05:00:33 EST
Thanks for confirmation, I will fix this in lohit kannada. Was just wondering how many ardha_cons shapes need to be added in kannada.
Comment 20 Pravin Satpute 2013-01-04 05:52:49 EST
I have committed changes in lohit upstream. Aravinda, it will be very helpful if you can test it once and let me know what is remaining.

Basically i have added rule for so  "u0CB0 ZWJ (All Matra)" should give expected output now.
Comment 21 Aravinda 2013-01-04 09:57:05 EST
Pravin, Tested the modified font now. Works great in Harfbuzz and m17n. Still has issues in KDE, Pango and ICU. But the issue is fixed from Font side. We can close this bug.
Comment 22 Pravin Satpute 2013-01-06 02:25:55 EST
Thanks Aravinda for confirmation. Hoping soon harfbuzz will be integrated with QT and ICU.
Comment 23 Fedora End Of Life 2013-04-03 15:41:09 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 24 Pravin Satpute 2013-05-31 06:57:15 EDT
I am seeing this one works fine with Harfbuzz 0.9.17 as well with master version.

One bug is already open in upstream against Harfbuzz https://bugs.freedesktop.org/show_bug.cgi?id=58714

Closing this.

Note You need to log in before you can comment on or make changes to this bug.